package com.zcxk.tcpserver.controller;

import com.zcxk.tcpserver.entity.Document;
import com.zcxk.tcpserver.tcp.TcpSocketHandler;
import com.zcxk.tcpserver.tcp.generator.ConcentratorDemo;
import com.zcxk.tcpserver.util.ConvertCode;
import io.netty.buffer.ByteBuf;
import io.netty.buffer.Unpooled;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import java.util.List;

@Slf4j
@Controller
@ResponseBody
@RequestMapping("test")
@Api(tags = "测试")
public class TestController {

    @RequestMapping("test")
    public String test(
            @ApiParam(value = "channelId", required = true) @RequestParam String channelId
    ){
        System.out.println("连接个数："+TcpSocketHandler.channels.size());;
        TcpSocketHandler.channels.forEach(channel -> {
            ByteBuf bufff = Unpooled.buffer();//netty需要用ByteBuf传输
            bufff.writeBytes(ConvertCode.hexString2Bytes("1234"));//对接需要16进制
            channel.writeAndFlush(bufff);
        });
        return "test";
    }

    @RequestMapping("readTime")
    @ApiOperation(value = "查询时间")
    public String readTime(
            @ApiParam(value = "设备号", required = true) @RequestParam String deviceNo
    ){
        System.out.println("连接个数："+TcpSocketHandler.channels.size());;
        String result = ConcentratorDemo.readTime();
        TcpSocketHandler.channels.forEach(channel -> {
            ByteBuf bufff = Unpooled.buffer();//netty需要用ByteBuf传输
            bufff.writeBytes(ConvertCode.hexString2Bytes(result));//对接需要16进制
            channel.writeAndFlush(bufff);
        });
        return "test";
    }

    @RequestMapping("issueWaterMeterFiles")
    @ApiOperation(value = "下发水表档案")
    public String issueWaterMeterFiles(
            @ApiParam(value = "设备号", required = true) @RequestParam String deviceNo,
            @ApiParam(value = "设备号", required = true) @RequestBody List<Document> documents
    ){
        System.out.println("连接个数："+TcpSocketHandler.channels.size());;
        String result = ConcentratorDemo.issueWaterMeterFiles(deviceNo,documents);
        TcpSocketHandler.channels.forEach(channel -> {
            ByteBuf bufff = Unpooled.buffer();//netty需要用ByteBuf传输
            bufff.writeBytes(ConvertCode.hexString2Bytes(result));//对接需要16进制
            channel.writeAndFlush(bufff);
        });
        return "test";
    }

    @RequestMapping("delWaterMeterFiles")
    @ApiOperation(value = "删除水表档案")
    public String delWaterMeterFiles(
            @ApiParam(value = "设备号", required = true) @RequestParam String deviceNo,
            @ApiParam(value = "表序号", required = true) @RequestBody List<Integer> meterNos
    ){
        System.out.println("连接个数："+TcpSocketHandler.channels.size());;
        String result = ConcentratorDemo.delWaterMeterFiles(deviceNo,meterNos);
        TcpSocketHandler.channels.forEach(channel -> {
            ByteBuf bufff = Unpooled.buffer();//netty需要用ByteBuf传输
            bufff.writeBytes(ConvertCode.hexString2Bytes(result));//对接需要16进制
            channel.writeAndFlush(bufff);
        });
        return "test";
    }
}
