package com.zcxk.tcpserver.entity;

import com.zcxk.tcpserver.util.HexUtil;
import lombok.Data;

import java.util.List;

@Data
public class FrameFormat {

    //起始字符68H (字节数1)
    private String beginCharacter1 = "68";

    //长度L (字节数2)
    private String length1;

    //长度L (字节数2)
    private String length2;

    //起始字符68H  (字节数1)
    private String beginCharacter2 = "68";

    //控制域C  (字节数1)
    private String controlDomain;

    //地址域A  (字节数5)
    private String addressDomain;

    //应用层功能码AFN  (字节数1)
    private String afn;

    //帧序列域SEQ  (字节数1)
    private String seq;

    private List<DataUnit> dataUnitList;

    //消息认证码PW（下行）/事件计数器EC（上行ACD=1时）
    private String pwec;

    //时间标签Tp
    private String tp;

    //校验和CS (字节数1)
    private String cs;

    //结束字符16H (字节数1)
    private String endCharacter = "16";

    private String getUserData(){
        String temp = controlDomain + addressDomain + afn + seq;
        if (dataUnitList != null) {
            for (DataUnit dataUnit : dataUnitList) {
                temp += dataUnit.getIdentify()  + dataUnit.getData();
            }
        }
        return temp;
    }


    public String calculatedLength(){
        String temp = this.getUserData();
        String lengthTemp = HexUtil.Demical2Byte(temp.length()/2)+"01";
        String b = HexUtil.demical2Hex(HexUtil.ByteToDecimal(lengthTemp));

        return HexUtil.hexTransfer(HexUtil.fill(b,4,'0'));
    }

    public String checkout(){
        String temp = this.getUserData();

        int z = 0;
        String tempNum = "00";
        for(int i=0;i<temp.length()/2;i++){
            String a = temp.substring(z,z+2);
            tempNum = HexUtil.hexAddHex(tempNum,a);
            z = z+2;
        }
        String strh = tempNum.substring(tempNum.length() -2);
        return strh;
    }

    public String builFrameFormatStr(){
        String temp = beginCharacter1 + length1 + length2 + beginCharacter2 + this.getUserData() + cs + endCharacter;
        return temp.toUpperCase();
    }
}
