package com.zcxk.tcpserver.tcp;

import io.netty.bootstrap.ServerBootstrap;
import io.netty.channel.ChannelFuture;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Component;

import javax.annotation.PostConstruct;
import javax.annotation.PreDestroy;
import java.net.InetSocketAddress;

@Slf4j
@Component
public class TcpSocketServer {
    @Autowired
    @Qualifier("serverBootstrap")
    private ServerBootstrap b;

    @Autowired
    @Qualifier("tcpSocketAddress")
    private InetSocketAddress tcpSocketPort;

    private ChannelFuture serverChannelFuture;

    @PostConstruct
    public void start() throws Exception {
        log.info("Starting server at " + tcpSocketPort);
        serverChannelFuture = b.bind(tcpSocketPort).sync();
    }

    @PreDestroy
    public void stop() throws Exception {
        log.info("stop server at " + tcpSocketPort);
        serverChannelFuture.channel().closeFuture().sync();
    }

    public ServerBootstrap getB() {
        return b;
    }

    public void setB(ServerBootstrap b) {
        this.b = b;
    }

    public InetSocketAddress getTcpSocketPort() {
        return tcpSocketPort;
    }

    public void setTcpSocketPort(InetSocketAddress tcpSocketPort) {
        this.tcpSocketPort = tcpSocketPort;
    }
}
