package com.zcxk.tcpserver.tcp.generator;

import com.zcxk.tcpserver.entity.FrameFormat;
import com.zcxk.tcpserver.util.ConvertCode;
import com.zcxk.tcpserver.util.HexUtil;
import com.zcxk.tcpserver.util.StringUtil;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;

import java.util.List;

import static com.google.common.collect.Lists.newArrayList;

@Slf4j
public class ProtocolGenerator {

    public static int analysis(String str){
        str = str.toUpperCase();
        int result = 0;
        String strh = str.substring(str.length() -2);
        if(StringUtils.equals("0D",strh)){
            str = str.substring(0,str.length()-2);
        }
        //log.info(str);
        List<String> list = StringUtil.split(str,2);
        log.info(list.toString());
        FrameFormat frameFormat = new FrameFormat();
        frameFormat.setBeginCharacter1(list.get(0));
        frameFormat.setLength1(list.get(1)+list.get(2));
        frameFormat.setLength2(list.get(3)+list.get(4));
        frameFormat.setBeginCharacter2(list.get(5));
        frameFormat.setControlDomain(list.get(6));
        frameFormat.setAddressDomain(list.get(7)+list.get(8)+list.get(9)+list.get(10)+list.get(11));
        frameFormat.setAfn(list.get(12));
        frameFormat.setSeq(list.get(13));
        frameFormat.setCs(list.get(list.size()-2));
        frameFormat.setEndCharacter(list.get(list.size()-1));
        log.info(frameFormat.toString());

        String length = list.get(2)+list.get(1);
        //System.out.println(length);
        String lengthBin = HexUtil.hexString2binaryString(length);
        //System.out.println(lengthBin);
        String strBin2 = lengthBin.substring(lengthBin.length() -2);
        if(StringUtils.equals("01",strBin2)){
            lengthBin = lengthBin.substring(0,lengthBin.length()-2);
        }
        //System.out.println(lengthBin);

        int lengthInt = HexUtil.ByteToDecimal(lengthBin);
        //log.info("用户数据长度:"+lengthInt);

        List<String> userDatalist = newArrayList();

        for (int i = 0; i < lengthInt; i++) {
            userDatalist.add(list.get(6+i));
        }

        log.info(userDatalist.toString());
        if(StringUtils.equals(frameFormat.getAfn(),"8C")){
            if(StringUtils.equals(userDatalist.get(10),"01") && StringUtils.equals(userDatalist.get(11),"00")){
                log.info("读时间");
                List<String> weekMonth = StringUtil.split(userDatalist.get(16),1);
                //System.out.println(weekMonth);
                String weekMonthStr =  HexUtil.hexStringToByte(weekMonth.get(0));
                //System.out.println(weekMonthStr);
                String monthPrefix = weekMonthStr.substring(weekMonthStr.length() -1);
                //System.out.println(monthPrefix+weekMonth.get(1));
                log.info("时间："+"20"+userDatalist.get(17)+"年"+monthPrefix+weekMonth.get(1)+"月"+userDatalist.get(15)+"号 "+userDatalist.get(14)+"时"+userDatalist.get(13)+"分"+userDatalist.get(12)+"秒");
            }
        }

        //--功能:读档案;SEQ:8;帧状态:3;AFN:8A;FN:1;集中器编号:075527DB00;数量:2;测量点:1;水表电子号:021506003011;采集器编号:000000000004;测量点:2;水表电子号:021708000339;采集器编号:000000000004;
        //
        //-> 68 61 00 61 00 68 70 55 07 DB 27 00 8A 68 00 00 01 00 05 00 01 00 02 00 03 00 04 00 05 00 D5 16
        //68 E9 00 E9 00 68 88 55 07 DB 27 00 8A 68 00 00 01 00 02 00 01 00 11 30 00 06 15 02 00 00 00 10 00 00 00 00 04 00 00 00 00 00 02 00 39 03 00 08 17 02 00 00 00 10 00 00 00 00 04 00 00 00 00 00 C1 16 0D

        if(StringUtils.equals(frameFormat.getAfn(),"8A")){
            if(StringUtils.equals(userDatalist.get(10),"01") && StringUtils.equals(userDatalist.get(11),"00")){
                log.info("读文档");
                int num =  HexUtil.ByteToDecimal(HexUtil.hexString2binaryString(userDatalist.get(13)+userDatalist.get(12)));
                log.info("数量："+num);
                for (int i = 0; i < num; i++) {
                    log.info("测量点："+HexUtil.hex2decimal(userDatalist.get(15+ i *22)+userDatalist.get(14+ i *22)));
                    log.info("水表电子号："+userDatalist.get(21+ i *22)+userDatalist.get(20+ i *22)+userDatalist.get(19+ i *22)+userDatalist.get(18+ i *22)+userDatalist.get(17+ i *22)+userDatalist.get(16+ i *22));
                    log.info("采集器编号："+userDatalist.get(35+ i *22)+userDatalist.get(34+ i *22)+userDatalist.get(33+ i *22)+userDatalist.get(32+ i *22)+userDatalist.get(31+ i *22)+userDatalist.get(30+ i *22));
                }

            }
        }

        //--功能:读冻结数据;SEQ:9;帧状态:3;AFN:8C;FN:57;集中器编号:075527DB00;数量:2;测量点:1;当前累积用量: ;测量点:2;当前累积用量:000003.00;
        //
        //-> 68 4D 00 4D 00 68 70 55 07 DB 27 00 8C 69 00 00 01 07 02 02 00 01 00 02 00 D2 16
        //68 69 00 69 00 68 88 55 07 DB 27 00 8C 69 00 00 01 07 02 00 01 00 EE EE EE EE 02 00 00 03 00 00 A3 16 0D

        if(StringUtils.equals(frameFormat.getAfn(),"8C")) {
            if (StringUtils.equals(userDatalist.get(10), "01") && StringUtils.equals(userDatalist.get(11), "07")) {
                log.info("读冻结数据");
                int num =  HexUtil.ByteToDecimal(HexUtil.hexString2binaryString(userDatalist.get(13)+userDatalist.get(12)));
                log.info("数量："+num);
                for (int i = 0; i < num; i++) {
                    log.info("测量点："+HexUtil.hex2decimal(userDatalist.get(15+ i *6)+userDatalist.get(14+ i *6)));
                    if(StringUtils.equals(userDatalist.get(19+ i *6)+userDatalist.get(18+ i *6)+userDatalist.get(17+ i *6)+userDatalist.get(16+ i *6),"EEEEEEEE")){
                        log.info("当前累积用量：-");
                    }else {

                        log.info("当前累积用量："+userDatalist.get(19+ i *6)+userDatalist.get(18+ i *6)+userDatalist.get(17+ i *6)+"."+userDatalist.get(16+ i *6));
                    }
                }
            }
        }

        if(StringUtils.equals(frameFormat.getAfn(),"02")) {
            if (StringUtils.equals(userDatalist.get(8), "00")&&StringUtils.equals(userDatalist.get(9), "00")&&StringUtils.equals(userDatalist.get(10), "01") && StringUtils.equals(userDatalist.get(11), "00")) {
                log.info("登录");
                result = 1;
            }
        }
        if(StringUtils.equals(frameFormat.getAfn(),"02")) {
            if (StringUtils.equals(userDatalist.get(8), "00")&&StringUtils.equals(userDatalist.get(9), "00")&&StringUtils.equals(userDatalist.get(10), "04") && StringUtils.equals(userDatalist.get(11), "00")) {
                log.info("心跳");
                result = 2;
            }
        }

        if(StringUtils.equals(frameFormat.getAfn(),"00")) {
            if (StringUtils.equals(userDatalist.get(8), "00")&&StringUtils.equals(userDatalist.get(9), "00")) {
                log.info("确认报文");
                if(StringUtils.equals(userDatalist.get(10), "01") && StringUtils.equals(userDatalist.get(11), "00")){
                    log.info("全部确认");
                }
                if(StringUtils.equals(userDatalist.get(10), "02") && StringUtils.equals(userDatalist.get(11), "00")){
                    log.info("全部否认");
                }
                if(StringUtils.equals(userDatalist.get(10), "04") && StringUtils.equals(userDatalist.get(11), "00")){
                    log.info("逐个确认或否认");
                }
            }
        }

        if(StringUtils.equals(frameFormat.getAfn(),"8C")) {
            if (StringUtils.equals(userDatalist.get(8), "00")&&StringUtils.equals(userDatalist.get(9), "00")&&StringUtils.equals(userDatalist.get(10), "01") && StringUtils.equals(userDatalist.get(11), "01")) {
                log.info("版本");

                log.info("软件版本："+ConvertCode.hexString2String(userDatalist.get(12)+userDatalist.get(13))+"-"+ConvertCode.hexString2String(userDatalist.get(14)+userDatalist.get(15))+
                        "-"+ConvertCode.hexString2String(userDatalist.get(16))+"-"+ConvertCode.hexString2String(userDatalist.get(17)+userDatalist.get(18)+userDatalist.get(19)));
                log.info("硬件版本："+ConvertCode.hexString2String(userDatalist.get(20)+userDatalist.get(21))+"-"+ConvertCode.hexString2String(userDatalist.get(22)+userDatalist.get(23))+
                        "-"+ConvertCode.hexString2String(userDatalist.get(24))+"-"+ConvertCode.hexString2String(userDatalist.get(25)+userDatalist.get(26)+userDatalist.get(27)));
            }
        }
        return result;
    }
}
