package com.zcxk.tcpserver.util;

import java.math.BigInteger;
import java.text.NumberFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;

/**
 * 16进制工具类
 *
 * @author wilian.peng
 * @Description
 * @date 2018年12月20日 下午3:41:27
 */
public class HexUtil {
    /**
     * 16进制转10进制
     *
     * @param hex
     * @return
     */
    public static BigInteger hex2decimal(String hex) {
        BigInteger i = new BigInteger(hex, 16);
        return i;
    }


    /**
     * 10进制转16进制
     *
     * @param i
     * @return
     */
    public static String demical2Hex(int i) {
        String s = Integer.toHexString(i);
        return s;
    }

    /**
     * 16进制转2进制
     *
     * @param hex
     * @return
     */
    public static String hexStringToByte(String hex) {
        int i = Integer.parseInt(hex, 16);
        String str2 = Integer.toBinaryString(i);
        return str2;
    }

    /**
     * 2进制转10进制
     *
     * @param bytes
     * @return
     */
    public static int ByteToDecimal(String bytes) {
        BigInteger bi = new BigInteger(bytes, 2); // 转换为BigInteger类型
        return bi.intValue();
    }

    /**
     * 10进制转2进制
     *
     * @param n
     * @return
     */
    public static String Demical2Byte(int n) {
        String result = Integer.toBinaryString(n);
        return result;
    }

    /**
     * 16进制转2进制字符串
     *
     * @param hexString
     * @return
     */
    public static String hexString2binaryString(String hexString) {
        if (hexString == null || hexString.length() % 2 != 0)
            return null;
        String bString = "", tmp;
        for (int i = 0; i < hexString.length(); i++) {
            tmp = "0000" + Integer.toBinaryString(Integer.parseInt(hexString.substring(i, i + 1), 16));
            bString += tmp.substring(tmp.length() - 4);
        }
        return bString;
    }

    /**
     * 2进制转16进制
     *
     * @param bString
     * @return
     */
    public static String binaryString2hexString(String bString) {
        if (bString == null || bString.equals("") || bString.length() % 8 != 0)
            return null;
        StringBuffer tmp = new StringBuffer();
        int iTmp = 0;
        for (int i = 0; i < bString.length(); i += 4) {
            iTmp = 0;
            for (int j = 0; j < 4; j++) {
                iTmp += Integer.parseInt(bString.substring(i + j, i + j + 1)) << (4 - j - 1);
            }
            tmp.append(Integer.toHexString(iTmp));
        }
        return tmp.toString();
    }

    /**
     * 16进制转换成为string类型字符串
     *
     * @param hexStr
     * @return
     */
    public static String hexStr2Str(String hexStr) {
        String str = "0123456789ABCDEF";
        char[] hexs = hexStr.toCharArray();
        byte[] bytes = new byte[hexStr.length() / 2];
        int n;
        for (int i = 0; i < bytes.length; i++) {
            n = str.indexOf(hexs[2 * i]) * 16;
            n += str.indexOf(hexs[2 * i + 1]);
            bytes[i] = (byte) (n & 0xff);
        }
        return new String(bytes);
    }

    public static int binary2decimal(String str) {
        int len = str.length();
        char ch;
        int num = 0;
        for (int i = len - 1; i >= 0; i--) {
            ch = str.charAt(i);
            if (ch != '0' && ch != '1') {
                System.out.println("input wrong!!");
                break;
            }
            if (ch == '1') {
                num = (int) (num + Math.pow(2, (len - 1) - i));
            }
        }
        return num;
    }

    /**
     * 十进制转二进制
     *
     * @param decNum
     * @param digit
     * @return
     */
    public static String decimal2binary(int decNum, int digit) {
        String binStr = "";
        for (int i = digit - 1; i >= 0; i--) {
            binStr += (decNum >> i) & 1;
        }
        return binStr;
    }

    /**
     * 16进制高低位转换
     *
     * @param src
     * @return
     */
    public static String hexTransfer(String src) {
        if (src.length() % 2 != 0) {
            System.out.println("16进制数字长度错误!");
            return "";
        }
        // 按照2个字节进行截取
        List<String> tmp = new ArrayList<String>();
        for (int i = 0; i < src.length() / 2; i++) {
            tmp.add(src.substring(i * 2, (i + 1) * 2));
        }
        Collections.reverse(tmp);
        StringBuffer sb = new StringBuffer();
        for (String str : tmp) {
            sb.append(str);
        }
        return sb.toString();
    }

    /**
     * 16进制加法
     *
     * @param hex1
     * @param hex2
     * @return
     */
    public static String hexAddHex(String hex1, String hex2) {
        BigInteger hi1 = hex2decimal(hex1);
        BigInteger hi2 = hex2decimal(hex2);
        return demical2Hex(hi1.add(hi2).intValue());
    }

    /**
     * 16进制减法
     *
     * @param hex1
     * @param hex2
     * @return
     */
    public static String hexSubHex(String hex1, String hex2) {
        BigInteger hi1 = hex2decimal(hex1);
        BigInteger hi2 = hex2decimal(hex2);
        return demical2Hex(hi1.subtract(hi2).intValue());
    }

    /**
     * 16进制减法(去掉补码)
     *
     * @param hex1
     * @param hex2
     * @return
     */
    public static String hexSubtractHex(String hex1, String hex2) {
        BigInteger hi1 = hex2decimal(hex1);
        BigInteger hi2 = hex2decimal(hex2);
        return Integer.toHexString(hi1.subtract(hi2).intValue() & 0xFF).toUpperCase();
    }

    /**
     * "7dd",4,'0'==>"07dd"
     * @param input 需要补位的字符串
     * @param size 补位后的最终长度
     * @param symbol 按symol补充 如'0'
     * @return
     * N_TimeCheck中用到了
     */
    public static String fill(String input, int size, char symbol) {
        while (input.length() < size) {
            input = symbol + input;
        }
        return input;
    }

    public static String hexToSingle(String t) {
        Float value = Float.intBitsToFloat(Integer.valueOf(t, 16));
        return value.toString();
    }

    public static byte[] hexStringToBytes(String hexString) {
        if (hexString == null || hexString.equals("")) {
            return null;
        }
        hexString = hexString.toUpperCase();
        int length = hexString.length() / 2;
        char[] hexChars = hexString.toCharArray();
        byte[] d = new byte[length];
        for (int i = 0; i < length; i++) {
            int pos = i * 2;
            d[i] = (byte) (charToByte(hexChars[pos]) << 4 | charToByte(hexChars[pos + 1]));
        }
        return d;
    }

    /**
     * 保留小数
     * @param num
     * @param length
     * @return
     */
    public static String reserveDecimal(Double num, int length) {
        String format = "%." + length + "f";
        return String.format(format, num);
    }

    /**
     * 十六进制补位(不足补0)
     * @param s
     * @param length
     * @return
     */
    public static String padLeft(String s, int length)
    {
        byte[] bs = new byte[length];
        byte[] ss = s.getBytes();
        Arrays.fill(bs, (byte) (48 & 0xff));
        System.arraycopy(ss, 0, bs,length - ss.length, ss.length);
        return new String(bs);
    }

    public static String binaryPadLeft(String s)
    {
        int number = HexUtil.ByteToDecimal(s);
        NumberFormat formatter = NumberFormat.getNumberInstance();
        formatter.setMinimumIntegerDigits(4);
        formatter.setGroupingUsed(false);
        return formatter.format(number);
    }


    private static byte charToByte(char c) {
        return (byte) "0123456789ABCDEF".indexOf(c);
    }

    public static void printComplementCode(int a)
    {
        for (int i = 0; i < 32; i++)
        {
            // 0x80000000 是一个首位为1，其余位数为0的整数
            int t = (a & 0x80000000 >>> i) >>> (31 - i);
            System.out.print(t);
        }
        System.out.println();
    }
    // 16进制转浮点小数
    public static float hexStringToFloat(String hexString) {
	    Long l = Long.parseLong(hexString, 16);
	    return Float.intBitsToFloat(l.intValue());
	}
    // 电磁水表换算 华旭提供
    public static int dchs(String hexString) {
		int temp = 0;
		for (int i = 0; i < 8; i++) {
			temp += (Integer.parseInt(hexString.substring(i, i + 1), 16) * Math.pow(16, 7 - i));
		}
		return temp;
	}
    //	000101100100‬
    public static void main(String args[]) {
        // 0x9a 0x99 0x69 0x40
//		Float value = Float.intBitsToFloat(Integer.valueOf("4069999a", 16));
        //System.out.println(HexUtil.hexToSingle(hexTransfer("9a996940")));
        // 41 d0 00 00

        //System.out.println(HexUtil.hex2decimal("ce"));
//		System.out.println(HexUtil.hexString2binaryString("18"));
        //System.out.println("000101100100".length());
        //System.out.println("00000001".substring(7));
        //System.out.println(HexUtil.binary2decimal("000101100100"));
		//System.out.println(HexUtil.binaryString2hexString("00001000"));
        System.out.println(ConvertCode.hexString2String("313838"));
        System.out.println(HexUtil.hexTransfer(HexUtil.fill(HexUtil.demical2Hex(1),4,'0')));
//		System.out.println(HexUtil.hexStr2Str("020010"));
//		String reverse = StringUtils.reverse("12345678");
//		System.out.println(reverse);
//		System.out.println(reverse.substring(0, 2+1));
//		System.out.println(reverse.substring(3, 3+1));
//		System.out.println(reverse.substring(4, 5+1));
//		System.out.println(reverse.substring(6, 7+1));
		
//		System.out.println(Integer.parseInt(HexUtil.hexSubHex("333333a7", "33333333")));
//		System.out.println(HexUtil.hex2decimal("cb933333"));
//		System.out.println(HexUtil.hexTransfer("a7333333")); // 33433333
//
//        System.out.println(HexUtil.hexTransfer("937834"));
//        System.out.println(Integer.parseInt(HexUtil.hexSubHex("347893", "333333")));
//        System.out.println(HexUtil.hex2decimal("cb933333"));
//        System.out.println(reserveDecimal(13.12901D,6));
        //System.out.println(HexUtil.hexTransfer("f1"));

		//System.out.println(Integer.parseInt(HexUtil.hexSubHex("333333a7", "33333333")));
		//System.out.println(HexUtil.hex2decimal("cb933333"));
		//System.out.println(HexUtil.hexTransfer("a7333333")); // 33433333

        //System.out.println(HexUtil.hexTransfer("937834"));
        //System.out.println(Integer.parseInt(HexUtil.hexSubHex("347893", "333333")));
        //System.out.println(HexUtil.hex2decimal("FD").intValue());
        //System.out.println(demical2Hex(-1000));
        //System.out.println(HexUtil.binary2decimal("11101"));
        //int i = 0xFD;
        System.out.println(Integer.toBinaryString(~new BigInteger("FD", 16).intValue()).substring(24,32));
        System.out.println(hexString2binaryString("FD"));
        System.out.println(-ByteToDecimal(Integer.toBinaryString(~new BigInteger("f", 16).intValue()).substring(24,32))-1);

        BigInteger hi1 = hex2decimal("3333");
        BigInteger hi2 = hex2decimal("3334");
        String s = "FF";
        System.out.println();
        // T(com.zcxk.smartcity.data.access.util.HexUtil).
        //   hexString2binaryString(T(com.zcxk.smartcity.data.access.util.HexUtil).
        //     padLeft(T(com.zcxk.smartcity.data.access.util.HexUtil).
        //       hexSubHex(T(com.zcxk.smartcity.data.access.util.HexUtil).
        //         hexTransfer(#value),'3333'),4)).substring(9,10)
        System.out.println(HexUtil.hexString2binaryString(HexUtil.padLeft(HexUtil.hexSubHex(HexUtil.hexTransfer("9333"),"3333"),4)).substring(9,10));
        System.out.println(Integer.toHexString(hi1.subtract(hi2).intValue() & 0xFF).toUpperCase());
        System.out.println(Integer.toHexString(hi1.subtract(hi2).intValue() & 0xFF).toUpperCase());
    }




}
